# :B:illBöt

_To :b:reserve and prötec_

This will be a [Matrix][matrix] bot used to track
informal debts between some (small) group of individuals.

its goals are (in order of importance):
1. any party can recalculate their position(s) even when the bot is unreachable.
2. support 1-to-1 and 1-to-many "transactions".
3. transactions may be visible to only the direct parties involved.
4. upgradable without any manual migration.
5. optional reminders for outstanding debts.

but so far, :B:illBöt achieves exactly 0 of these 🙃


## Roadmap

a few proposals:
- [doc/roadmap-bot.md](doc/roadmap-bot.md)
- [doc/roadmap-widget.md](doc/roadmap-widget.md)


## Development/Hacking

this project is built with [cargo][cargo], the [Rust][rust] package manager. simply run:

```sh
$ cargo build
$ ./target/debug/billbot
```

it can also be built with [nix][nix]:
```sh
$ nix build
$ ./result/bin/billbot
```

a nix development environment (i.e. access to the correct toolchain) can be entered like so:
```sh
$ nix develop
```

after which ordinary cargo commands can be used:
```sh
nix-shell> cargo build
nix-shell> ./target/debug/billbot
```

refer to <./doc/resources.md> for code-related documentation.

[matrix]: https://matrix.org
[cargo]: https://doc.rust-lang.org/cargo
[rust]: https://rust-lang.org
[nix]: https://nixos.org
